unit MonoMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, System.Types, System.UITypes,
  System.UIConsts, Math;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    MonoColorBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    ScrollBar2: TScrollBar;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MonoColorBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private 錾 }
    procedure TemplateMake;      // Templatef[^[쐬
    procedure ColorBar;          // J[o[}
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                            // \gTCY

  RK    = 0.298912;                           // O[XP[PxW@
  GK    = 0.586611;                           // O[XP[PxW@
  BK    = 0.114478;                           // O[XP[PxW@

var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY
  Vrect           : Trect;                    // \g
  IHeight, IWidth : Integer;                  // \TCY
  MonoColorTemp   : array[0..255] of Trgbtriple;  // ev[gpz

// J[o[}
procedure TForm1.ColorBar;
var
  h   : integer;
  hue : double;
  st  : double;
  Cor : TColor;
begin
  st := Scrollbar2.Position / 255;
  for h := 0 to 360 do begin
    hue := h / 360;
    Cor := HSLtoRGB(hue, st, 0.5);            // x0.5  0.5 F
    Image2.Canvas.Pen.Color := Cor and $00FFFFFF;
    Image2.Canvas.MoveTo(h, 0);
    Image2.Canvas.LineTo(h, image2.Height);
  end;
end;

// Templatef[^[쐬
procedure TForm1.TemplateMake;
var
  L   : integer;
  hu  : double;
  st  : double;
  Cor : TColor;
begin
  // ʓxl
  st := Scrollbar2.Position / 255;
  // Fl
  hu := Scrollbar1.Position / 360;
  // xl
  for L := 0 to 255 do begin
    Cor := HSLtoRGB(hu, st, L / 255) and $00FFFFFF;
    MonoColorTemp[L].rgbtBlue  := GetBValue(Cor);
    MonoColorTemp[L].rgbtGreen := GetGValue(Cor);
    MonoColorTemp[L].rgbtRed   := GetRValue(Cor);
  end;
end;

// NTSCWŋPxϊXMonocolorɕϊ܂
procedure TForm1.MonoColorBtnClick(Sender: TObject);          // ZsAFϊ
var
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Prgbarray;
  GrayByte      : BYTE;
begin
  ColorBar;
  TemplateMake;                                               // Templatef[^[쐬
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin
      GrayByte := Round(InpPrgbarray[JJ].rgbtBlue  * BK +
                        InpPrgbarray[JJ].rgbtGreen * GK +
                        InpPrgbarray[JJ].rgbtRed   * RK);
      OutParray[JJ] := MonoColorTemp[GrayByte];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
  FileSaveBtn.Enabled   := True;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  MonoColorBtnClick(nil);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  ColorBar;
  MonoColorBtnClick(nil);
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  MonoColorBtn.Enabled  := False;
  FileSaveBtn.Enabled   := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width := GWidth;
        OutBitmap.Height:= GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  MonoColorBtn.Enabled   := True;
end;

// t@Cւ̕ۑ
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  MonoColorBtn.Enabled := False;
  FileSaveBtn.Enabled   := False;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  InBitmap      := TBitmap.Create;        // ͉摜p
  OutBitmap     := TBitmap.Create;        // 24rbgo͗p
  InBitmap.PixelFormat    := pf24bit;     // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;     // 24rbgJ[ɐݒ
  image2.Width := 361;
  scrollbar2.Position := 255;
end;

// rbg}bv̉
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
